=== modified file 'ChangeLog'
--- ChangeLog	2006-07-17 20:24:24 +0000
+++ ChangeLog	2006-07-18 15:33:52 +0000
@@ -1,3 +1,9 @@
+2006-07-18  Szilveszter Farkas <Szilveszter.Farkas@gmail.com>
+
+    * olive/backend/init.py: added NotBranchError handling to branch()
+    * olive/frontend/gtk/__init__.py: added OliveCommunication class
+    * olive/frontend/gtk/branch.py: finished implementation of Branch window
+
 2006-07-17  Szilveszter Farkas <Szilveszter.Farkas@gmail.com>
 
     * olive.glade: signals added + Branch dialog modifications

=== modified file 'olive.glade'
--- olive.glade	2006-07-17 20:24:24 +0000
+++ olive.glade	2006-07-18 15:33:52 +0000
@@ -645,6 +645,7 @@
 </widget>
 
 <widget class="GtkWindow" id="window_branch">
+  <property name="width_request">350</property>
   <property name="title" translatable="yes">Olive - Branch</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
   <property name="window_position">GTK_WIN_POS_NONE</property>
@@ -669,7 +670,7 @@
       <child>
 	<widget class="GtkTable" id="table_branch">
 	  <property name="visible">True</property>
-	  <property name="n_rows">6</property>
+	  <property name="n_rows">5</property>
 	  <property name="n_columns">2</property>
 	  <property name="homogeneous">False</property>
 	  <property name="row_spacing">3</property>
@@ -772,50 +773,6 @@
 	  </child>
 
 	  <child>
-	    <widget class="GtkCheckButton" id="checkbutton_branch_lightweight">
-	      <property name="visible">True</property>
-	      <property name="can_focus">True</property>
-	      <property name="label" translatable="yes">Lightweight checkout</property>
-	      <property name="use_underline">True</property>
-	      <property name="relief">GTK_RELIEF_NORMAL</property>
-	      <property name="focus_on_click">True</property>
-	      <property name="active">False</property>
-	      <property name="inconsistent">False</property>
-	      <property name="draw_indicator">True</property>
-	    </widget>
-	    <packing>
-	      <property name="left_attach">1</property>
-	      <property name="right_attach">2</property>
-	      <property name="top_attach">5</property>
-	      <property name="bottom_attach">6</property>
-	      <property name="x_options">fill</property>
-	      <property name="y_options"></property>
-	    </packing>
-	  </child>
-
-	  <child>
-	    <widget class="GtkCheckButton" id="checkbutton_branch_checkout">
-	      <property name="visible">True</property>
-	      <property name="can_focus">True</property>
-	      <property name="label" translatable="yes">Checkout</property>
-	      <property name="use_underline">True</property>
-	      <property name="relief">GTK_RELIEF_NORMAL</property>
-	      <property name="focus_on_click">True</property>
-	      <property name="active">False</property>
-	      <property name="inconsistent">False</property>
-	      <property name="draw_indicator">True</property>
-	    </widget>
-	    <packing>
-	      <property name="left_attach">1</property>
-	      <property name="right_attach">2</property>
-	      <property name="top_attach">4</property>
-	      <property name="bottom_attach">5</property>
-	      <property name="x_options">fill</property>
-	      <property name="y_options"></property>
-	    </packing>
-	  </child>
-
-	  <child>
 	    <widget class="GtkLabel" id="label_branch_revno">
 	      <property name="visible">True</property>
 	      <property name="label" translatable="yes">Revision number:</property>
@@ -836,58 +793,9 @@
 	    <packing>
 	      <property name="left_attach">0</property>
 	      <property name="right_attach">1</property>
-	      <property name="top_attach">3</property>
-	      <property name="bottom_attach">4</property>
-	      <property name="x_options">fill</property>
-	      <property name="y_options"></property>
-	    </packing>
-	  </child>
-
-	  <child>
-	    <widget class="GtkLabel" id="label_branch_localnick">
-	      <property name="visible">True</property>
-	      <property name="label" translatable="yes">Local nick:</property>
-	      <property name="use_underline">False</property>
-	      <property name="use_markup">False</property>
-	      <property name="justify">GTK_JUSTIFY_LEFT</property>
-	      <property name="wrap">False</property>
-	      <property name="selectable">False</property>
-	      <property name="xalign">0</property>
-	      <property name="yalign">0.5</property>
-	      <property name="xpad">0</property>
-	      <property name="ypad">0</property>
-	      <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
-	      <property name="width_chars">-1</property>
-	      <property name="single_line_mode">False</property>
-	      <property name="angle">0</property>
-	    </widget>
-	    <packing>
-	      <property name="left_attach">0</property>
-	      <property name="right_attach">1</property>
-	      <property name="top_attach">2</property>
-	      <property name="bottom_attach">3</property>
-	      <property name="x_options">fill</property>
-	      <property name="y_options"></property>
-	    </packing>
-	  </child>
-
-	  <child>
-	    <widget class="GtkEntry" id="entry_branch_localnick">
-	      <property name="visible">True</property>
-	      <property name="can_focus">True</property>
-	      <property name="editable">True</property>
-	      <property name="visibility">True</property>
-	      <property name="max_length">0</property>
-	      <property name="text" translatable="yes"></property>
-	      <property name="has_frame">True</property>
-	      <property name="invisible_char">●</property>
-	      <property name="activates_default">False</property>
-	    </widget>
-	    <packing>
-	      <property name="left_attach">1</property>
-	      <property name="right_attach">2</property>
-	      <property name="top_attach">2</property>
-	      <property name="bottom_attach">3</property>
+	      <property name="top_attach">2</property>
+	      <property name="bottom_attach">3</property>
+	      <property name="x_options">fill</property>
 	      <property name="y_options"></property>
 	    </packing>
 	  </child>
@@ -907,8 +815,52 @@
 	    <packing>
 	      <property name="left_attach">1</property>
 	      <property name="right_attach">2</property>
+	      <property name="top_attach">2</property>
+	      <property name="bottom_attach">3</property>
+	      <property name="y_options"></property>
+	    </packing>
+	  </child>
+
+	  <child>
+	    <widget class="GtkCheckButton" id="checkbutton_branch_checkout">
+	      <property name="visible">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="label" translatable="yes">Checkout</property>
+	      <property name="use_underline">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <property name="active">False</property>
+	      <property name="inconsistent">False</property>
+	      <property name="draw_indicator">True</property>
+	    </widget>
+	    <packing>
+	      <property name="left_attach">1</property>
+	      <property name="right_attach">2</property>
 	      <property name="top_attach">3</property>
 	      <property name="bottom_attach">4</property>
+	      <property name="x_options">fill</property>
+	      <property name="y_options"></property>
+	    </packing>
+	  </child>
+
+	  <child>
+	    <widget class="GtkCheckButton" id="checkbutton_branch_lightweight">
+	      <property name="visible">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="label" translatable="yes">Lightweight checkout</property>
+	      <property name="use_underline">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <property name="active">False</property>
+	      <property name="inconsistent">False</property>
+	      <property name="draw_indicator">True</property>
+	    </widget>
+	    <packing>
+	      <property name="left_attach">1</property>
+	      <property name="right_attach">2</property>
+	      <property name="top_attach">4</property>
+	      <property name="bottom_attach">5</property>
+	      <property name="x_options">fill</property>
 	      <property name="y_options"></property>
 	    </packing>
 	  </child>

=== modified file 'olive/backend/errors.py'
--- olive/backend/errors.py	2006-07-08 17:36:59 +0000
+++ olive/backend/errors.py	2006-07-18 15:33:52 +0000
@@ -162,6 +162,7 @@
     
     May occur in:
         commit.commit()
+        init.branch()
     """
 
 class NotVersionedError(OliveError):

=== modified file 'olive/backend/init.py'
--- olive/backend/init.py	2006-07-08 17:36:59 +0000
+++ olive/backend/init.py	2006-07-18 15:33:52 +0000
@@ -27,7 +27,7 @@
 
 from errors import (AlreadyBranchError, BranchExistsWithoutWorkingTree,
                     NonExistingParent, NonExistingRevision,
-                    NonExistingSource, TargetAlreadyExists)
+                    NonExistingSource, NotBranchError, TargetAlreadyExists)
 
 def init(location):
     """ Initialize a directory.
@@ -75,6 +75,8 @@
             raise NonExistingSource(from_location)
         else:
             raise
+    except errors.NotBranchError:
+        raise NotBranchError(from_location)
 
     br_from.lock_read()
 

=== modified file 'olive/frontend/gtk/__init__.py'
--- olive/frontend/gtk/__init__.py	2006-07-17 20:24:24 +0000
+++ olive/frontend/gtk/__init__.py	2006-07-18 15:33:52 +0000
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+import os
+import os.path
 import sys
 
 try:
@@ -37,8 +39,6 @@
     program."""
     
     def __init__(self):
-        import os.path
-        
         # Load the glade file
         self.gladefile = "/usr/share/olive/olive.glade"
         if not os.path.exists(self.gladefile):
@@ -50,7 +50,8 @@
         self.window = self.toplevel.get_widget('window_main')
         self.window.show_all()
         
-        handler = OliveHandler(self.gladefile)
+        self.comm = OliveCommunicator(self.toplevel)
+        handler = OliveHandler(self.gladefile, self.comm)
         
         # Dictionary for signal_autoconnect
         dic = { "on_window_main_destroy": gtk.main_quit,
@@ -75,9 +76,6 @@
         
     def _load_right(self):
         """ Load data into the right panel. (Filelist) """
-        import os
-        import os.path
-        
         import olive.backend.fileops as fileops
         
         # Create ListStore
@@ -87,7 +85,7 @@
         files = []
         
         # Fill the appropriate lists
-        for item in os.listdir('.'):
+        for item in os.listdir(self.comm.get_path()):
             if os.path.isdir(item):
                 dirs.append(item)
             else:
@@ -120,3 +118,36 @@
         tvcolumn_filename.add_attribute(cell, 'text', 1)
         tvcolumn_status.pack_start(cell, True)
         tvcolumn_status.add_attribute(cell, 'text', 2)
+
+class OliveCommunicator:
+    """ This class is responsible for the communication between the different
+    modules. """
+    def __init__(self, toplevel):
+        # Get glade main component
+        self.toplevel = toplevel
+        # Default path
+        self._path = os.getcwd()
+        
+        # Initialize the statusbar
+        self.statusbar = self.toplevel.get_widget('statusbar')
+        self.context_id = self.statusbar.get_context_id('olive')
+    
+    def set_path(self, path):
+        """ Set the current path while browsing the directories. """
+        self._path = path
+    
+    def get_path(self):
+        """ Get the current path. """
+        return self._path
+
+    def set_statusbar(self, message):
+        """ Set the statusbar message. """
+        self.statusbar.push(self.context_id, message)
+    
+    def clear_statusbar(self):
+        """ Clean the last message from the statusbar. """
+        self.statusbar.pop(self.context_id)
+    
+    def refresh_right(self):
+        """ Refresh the file list. """
+        pass

=== modified file 'olive/frontend/gtk/handler.py'
--- olive/frontend/gtk/handler.py	2006-07-17 20:24:24 +0000
+++ olive/frontend/gtk/handler.py	2006-07-18 15:33:52 +0000
@@ -32,15 +32,17 @@
 
 class OliveHandler:
     """ Signal handler class for Olive. """
-    def __init__(self, gladefile):
+    def __init__(self, gladefile, comm):
         self.gladefile = gladefile
+        self.comm = comm
+        
         self.dialog = OliveDialog(self.gladefile)
     
     def on_about_activate(self, widget):
         self.dialog.about()
         
     def on_menuitem_branch_branch_activate(self, widget):
-        branch = OliveBranch(self.gladefile)
+        branch = OliveBranch(self.gladefile, self.comm)
         branch.display()
     
     def not_implemented(self, widget):

